/*
 * UPIWIN - Micro Pi Windowing Framework Kernel
 * Copyright (C) 2019 Amy Bowersox/Erbosoft Metaverse Design Solutions
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *-------------------------------------------------------------------------
 */
#include <stdlib.h>
#include <string.h>
#include "gfxobj.h"

void _Go_init(PGFXOBJECT obj, UINT32 sig, UINT32 size)
{
  memset(obj, 0, sizeof(GFXOBJECT));
  obj->sig = sig;
  obj->size = size;
  obj->refcnt = 1;
}

void Go_unchain(PGFXOBJECT obj)
{
  if (!(obj->next || obj->prev))
    return;
  if (obj->next)
    obj->next->prev = obj->prev;
  if (obj->prev)
    obj->prev->next = obj->next;
  obj->prev = obj->next = NULL;
}

INT32 Go_addref(PGFXOBJECT obj)
{
  return ++(obj->refcnt);
}

INT32 Go_release(PGFXOBJECT obj)
{
  int rc = --(obj->refcnt);
  if (rc == 0)
  {
    if (obj->dtor)
      (*(obj->dtor))(obj);
    free(obj);
  }
  return rc;
}
